var callbacks = {};

function genUuid() {
	function s4() {
		return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
	}
	return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}

function callback(data) {
	console.log(data);
	callbacks[data.uuid](data);
	delete callbacks[data.uuid];
}

function request(type, data, callback) {
	data = data ? data : {};
	data.jsType = type;
	if (callback) {
		var uuid = genUuid();
		data.uuid = uuid;
		callbacks[uuid] = callback;
	}
	window.webkit.messageHandlers.app.postMessage(data);
}

function renderPartial(data) {
	$(data.container).html(data.html);
}

function updateClickCounter(data) {
    $('#button-click-counter-p').html("" + data.count + " clicks");
}

function buttonScannerEvent(event) {
    
    if (event.type == 'setPane') {
        
        $('#scan-wizard-title').text(event.title);
        $('#scan-wizard-subtitle-1').text(event.subtitle1);
        $('#scan-wizard-subtitle-2').text(event.subtitle2);
        
        $('#scan-wizard-segment-1').removeClass('selected');
        $('#scan-wizard-segment-2').removeClass('selected');
        $('#scan-wizard-segment-3').removeClass('selected');
        
        $('#scan-wizard-segment-' + event.segment).addClass('selected');
        
        if (event.pane == 'searchingPane') {
            $("#scan-wizard-center-logo-img").attr("src","main-push-flic.png");
            $("#scan-wizard-center-logo-img").attr("width","200");
            $("#scan-wizard-cirlular-loader-div").hide();
        } else if (event.pane == 'privateButtonsPane') {
            $("#scan-wizard-center-logo-img").attr("src","search_button_private.png");
            $("#scan-wizard-center-logo-img").attr("width","200");
            $("#scan-wizard-cirlular-loader-div").hide();
        } else if (event.pane == 'errorPane') {
            $("#scan-wizard-center-logo-img").attr("src","search_wizard_error.png");
            $("#scan-wizard-center-logo-img").attr("width","200");
            $("#scan-wizard-cirlular-loader-div").hide();
        } else if (event.pane == 'connectingPane') {
            $("#scan-wizard-center-logo-img").attr("src","logo-lg-purple.png");
            $("#scan-wizard-center-logo-img").attr("width","60");
            $("#scan-wizard-cirlular-loader-div").show();
        } else if (event.pane == 'connectedPane') {
            //$("#scan-wizard-center-logo-img").attr("src","main_flic_white.png");
            $("#scan-wizard-center-logo-img").attr("src","provider_configured_icon_large.png");
            //$("#scan-wizard-center-logo-img").addClass(event.color);
            $("#scan-wizard-center-logo-img").attr("width","156");
            $("#scan-wizard-cirlular-loader-div").hide();
        } else if (event.pane == 'bluetoothOffPane') {
            $("#scan-wizard-center-logo-img").attr("src","main_add_flic_bluetooth_off_icon.png");
            $("#scan-wizard-center-logo-img").attr("width","178");
            $("#scan-wizard-cirlular-loader-div").hide();
        }
        
    } else if (event.type == 'updateProgressCircle') {
        updateScanWizardCircle(event.degree);
    }
    
}

function blockContextMenu() {
    $('body').on("contextmenu", function (e) {
                 e.preventDefault();
    });
}

function polarToCartesian(centerX, centerY, radius, angleInDegrees) {
    var angleInRadians = (angleInDegrees - 90) * Math.PI / 180.0;
    
    return { x: centerX + (radius * Math.cos(angleInRadians)), y: centerY + (radius * Math.sin(angleInRadians)) };
};

function describeArc(x, y, radius, startAngle, endAngle) {
    var start = polarToCartesian(x, y, radius, endAngle);
    var end = polarToCartesian(x, y, radius, startAngle);
    var arcSweep = endAngle - startAngle <= 180 ? "0" : "1";
    var d = [ "M", start.x, start.y, "A", radius, radius, 0, arcSweep, 0, end.x, end.y ].join(" ");
    return d;
};

function updateScanWizardCircle(degree) {
    var d = describeArc(92,92,90,0,degree);
    $('#scan-wizard-circular-progress-path').attr('d', d);
};

function loginSignupSwitch() {
    $('#signup-first-and-last-name').animate({height: 'toggle'}, 300, function() {});
    
    if ($('#login-signtup-switch-value').val() == 'login') {
        $('#login-signtup-switch-value').val('signup');
        $('#signin-signup-switch').html('EXISTING ACCOUNT');
        $('#login-error-message').html('');
        $('#login-submit-button').val('SIGN UP');
    } else {
        $('#login-signtup-switch-value').val('login');
        $('#signin-signup-switch').html('CREATE ACCOUNT');
        $('#login-error-message').html('');
        $('#login-submit-button').val('LOGIN');
    }
}

function termsOfUseSwitch() {
    $('#signin-signup-content').animate({height: 'toggle'}, 300, function() {});
    $('#signin-signup-hello-friend').animate({height: 'toggle'}, 300, function() {});
    $('#signin-signup-lower-area').animate({height: 'toggle'}, 300, function() {});
}

function forgotPassword() {
    request('loginOrSignup', {'type': 'resetpassword'});
}

function termsOfUse() {
    request('loginOrSignup', {'type': 'termsofuse'});
}

